#include <unistd.h>
#include <stdio.h>
#include <pwd.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>

/* HEY, fails on pathnames ending in "." or ".."! */

#define BUFSIZE 1024*sizeof(char)

char *CanonPath(char *filename) {

  char *path, *original_path;
  char *linkexpan;
  struct stat *statbuf;
  int linklen;
  int statret;
  char *temprchr;
  int dirtmp;
  char *shortname;

  linkexpan = (char *) malloc(BUFSIZE);
  statbuf = (struct stat *) malloc(sizeof(struct stat));
  path = (char *) malloc(BUFSIZE);
  shortname = (char *) malloc(BUFSIZE);

  original_path = getcwd(NULL, BUFSIZE);

  if (filename[strlen(filename) - 1] == (char) '/') {
    filename[strlen(filename) - 1] = NULL;
  }

  strcpy(path, filename);

/* Begin loop */

  while ( (linklen = readlink(path, linkexpan, BUFSIZE)) > -1) {

    linkexpan[linklen] = NULL;
    if ( (statret = stat(filename, statbuf)) == -1) {
      perror("stat error!");
      printf("stat errno: %d\n", errno);
    }
    else {
      if ( (statbuf->st_mode & S_IFMT) == S_IFDIR) {
      }
      /* What we have is a symlink to another file
         Replace the symlink with its expansion, and try this whole
         thing again.
      */
      if (linkexpan[0] == (char) '/') {
        /*
         If the expansion starts with a "/", replace the entire path
         with it.
        */
        strcpy(path, linkexpan);
      } 
      else {
        /* Chop the last field off path and replace it with linkexpan */
        /* This will fail if the path ends with a "/"!!! We should get
           rid of those in the beginning.
              Then again, assuming we are always looking at a FILE not
              a directory, we be ok! */

        if ( (temprchr = (char *) strrchr(path, (char) '/')) == NULL) {
           strcpy(path, linkexpan);
        }
        else {
          path[strlen(path) - strlen(temprchr) + 1] = NULL;
          strcat(path, linkexpan);
        }
      }
    }
  }


  if (linklen != -1) {
    printf ("This should not have happened!\n");
  }
  else {
   /* perror("readlink:"); */
    if (errno == EINVAL) {
    }
    else {
      if (errno == ENOENT) {
        return filename;
      }
      else {
        printf("A serious readlink error has occurred. narf.\n");
        exit(3);
      }
    }
  }

  /* Now we chop the filename off path, chdir to the resulting directory,
     and get_cwd there. Sticking the filename onto the result will give us
     the canonical name for that file! Then we chdir back. */ 

  if ( (temprchr = (char *) strrchr(path, (char) '/')) == NULL) {
    strcpy(shortname, path);
    /* get the cwd  - is path suitable for this? */
    path = getcwd(NULL, BUFSIZE);
    /* stick a slash onto the end of it */
    strcat(path, "/"); 
    /* stick the filename onto the end of it */
    strcat(path, shortname); 
  }
  else {
    strcpy(shortname, temprchr);
    /* Chop off the filename */
    path[strlen(path) - strlen(temprchr) + 1] = NULL;
    if ( (dirtmp = chdir(path)) == 0) {
      /* get the cwd  - is path suitable for this? */
      /* Path has been malloc()ed BUFSIZE */
      (void *) getcwd(path, BUFSIZE);
      /* stick the filename onto the end of it */
      strcat(path, shortname); 
      /* Change directories back. */
      if ( (dirtmp = chdir(original_path)) != 0) {
        perror("chdir error!");
      }
    }
    else {
      perror("chdir error!");
    }
  }

  free(original_path);
  free(linkexpan);
  free(statbuf);
  free(shortname);

  return path;

}
