#ifndef	__cfx_h
#define	__cfx_h

#define DEFAULT_IDENT_FILENUM		-99
#define DEFAULT_DECL_FILENUM		-199
#define DEFAULT_TYPE_FILENUM		-299
#define NULL_FILENAME_FILENUM		-399
#define NESTED_FUNCTION_FILENUM		-499

#define DEFAULT_IDENT_ORIGNODE		(tree) 0xBAD

#define USE_MACRO_IF_PRESENT		0
#define USE_CURRENT_FILE		1

#include "../common/modes.h"

/* Cfx Options */
extern int	cfx_oneFileOption;
extern int	cfx_allFactsOption;
extern int	cfx_noMrOption;
extern int	cfx_noHrOption;
extern int	cfx_noMinOption;
extern int	cfx_noIfcOption;
extern int	cfx_directOption;

/* Variables used in cfx_cpp and cfx_cc1 */
extern int	cfx_mode;
extern int	cfx_allFacts;
extern char	cfx_macroStartMarker [];
extern char	cfx_macroEndMarker [];
extern char	cfx_macroStartToken [];
extern char	cfx_macroEndToken [];

/* Variables used by cfx_cpp */
extern int	cfx_suppressMacroMarker;

/* Variables used by cfx_cc1 */
extern char	*cfx_baseName;
extern char	*cfx_cppName;
extern int	cfx_macroStartTokenLen;

/* Routines used by cfx_cc */
extern void	Cfx_Initialize ();
extern void	Cfx_Finalize ();
extern void	Cfx_CreateFileName ();

/* Routines used by cfx_cpp */
extern void	Cfx_CppInitialize (/* char *inFileName,
				      char *outFileName,
				      int allFacts, 
				      int direct */);
extern void	Cfx_CppFinalize (/* void */);
extern int	Cfx_AddFile (/* char *fileName, shortName, int len, ang_brk */);
extern void	Cfx_FileUsage (/* int fileUsingItem, *itemName */);
extern void	Cfx_MacroDefinition (/* int fileDefiningItem,
				        int lineDefiningItem,
				        char *itemName,
				        int itemNameLength */);
extern void	Cfx_MacroUsage (/* int fileUsingItem, *fileDefiningItem,
				   int lineDefiningItem, char *itemName */);
extern int	Cfx_IsIdentChar ();

/* Routines used by cfx_cc1 */
extern void	Cfx_Cc1Initialize (/* int allFacts, 
				      int direct,
				      char *baseFileName,
				      char *cppFileName,
				      char *origFileName */);
extern void	Cfx_Cc1Finalize (/* void */);
extern int	Cfx_GetFileNumber (/* char fileNumber */);
extern void	Cfx_PushMacroStack (/* char fileName */);
extern void	Cfx_PopMacroStack (/* void */);
extern void	Cfx_EnumItemDefinition (/* int fileAttributed,
					    int fileDefiningItem,
					    int lineDefiningItem,
					    char *itemName */);
extern void	Cfx_EnumTagDefinition (/* int fileAttributed,
					   int fileDefiningItem,
					   int lineDefiningItem,
					   char *itemName */);
extern void	Cfx_FcnDeclaration (/* int fileAttributed,
					int fileDefiningItem,
					int lineDefiningItem,
					int public,
					char *itemName */);
extern void	Cfx_GlobalFcnDefinition (/* int fileAttributed,
					     int fileDefiningItem,
					     int lineDefiningItem,
					     int public,
					     char *itemName */);
extern void	Cfx_GlobalVarDefinition (/* int fileAttributed,
					     int fileDefiningItem,
					     int lineDefiningItem,
					     int public,
					     char *itemName */);
extern void	Cfx_Import (/* int importType,
				int fileAttributed,
				int fileUsingItem,
				int fileDefiningItem,
				int lineDefiningItem,
				char *itemName */);
extern void	Cfx_StructOrUnionDefinition (/* int fileAttributed,
						 int fileDefiningItem,
						 int lineDefiningItem,
						 int isStruct;
						 char *itemName */);
extern void	Cfx_TypeDefinition (/* int fileAttributed,
					int fileDefiningItem,
					int lineDefiningItem,
					char *itemName */);
extern void	Cfx_VarDeclaration (/* int fileAttributed,
					int fileDefiningItem,
					int lineDefiningItem,
					char *itemName */);
extern void	Cfx_ImportSomething (/* tree symbol */);
#endif
