#include <stdio.h>
#include "tree.h"
#include "cfx.h"
#include "../include/cfx-internal.h"

void    Cfx_ImportSomething (symbol, fileAttributed, scopeName )
    tree symbol;
    int fileAttributed;
    char *scopeName;            /*GK*/
    
{
    int                 fileUsed;
    int                 symbolFileAttributed, symbolFileDeclared;
    int                 symbolLineDeclared;
    unsigned int        *symbolImported;
    char                *symbolName;
    int                 importType;

    
    switch (TREE_CODE_CLASS (TREE_CODE (symbol)))
    {
        case 'd':
            symbolFileAttributed = DECL_FILE_ATTRIBUTED (symbol);
            symbolFileDeclared = DECL_FILE_DECLARED (symbol);
            symbolLineDeclared = DECL_LINE_DECLARED (symbol);
            symbolImported = &(DECL_CFX_IMPORTED (symbol));
            symbolName = IDENTIFIER_POINTER (DECL_NAME (symbol));
            break;
        case 't':
            symbolFileAttributed = TYPE_FILE_ATTRIBUTED (symbol);
            symbolFileDeclared = TYPE_FILE_DECLARED (symbol);
            symbolLineDeclared = TYPE_LINE_DECLARED (symbol);
            symbolImported = &(TYPE_CFX_IMPORTED (symbol));
            symbolName = IDENTIFIER_POINTER (TYPE_NAME (symbol));
            break;
        default:
            fprintf (stderr, "[100] Trouble when importing a symbol!\n");
            exit (200);
    }

       
    if (((TREE_CODE (symbol) != VAR_DECL) && 
         (TREE_CODE (symbol) != FUNCTION_DECL)) ||
        (TREE_STATIC (symbol)))
    {
        if (fileAttributed == symbolFileAttributed)
        {
            return;
        }
    }
    /* This is used to detect a reference to a nested function */
    if ((TREE_CODE (symbol) != VAR_DECL) && 
        (symbolFileAttributed == NESTED_FUNCTION_FILENUM))
    {
        return;
    }
    
    if (fileAttributed <= 30)   /* GK What is the purpose of this if stmt */
    {
        if (((1 << fileAttributed) & *symbolImported) != 0)
        {
            return;
        }
        *symbolImported = *symbolImported | (1 << fileAttributed);
    }

    fileUsed = Cfx_GetFileNumber (USE_CURRENT_FILE, input_filename);

    if ((TREE_CODE (symbol) == CONST_DECL) &&
        (TREE_CODE (TREE_TYPE (symbol)) == ENUMERAL_TYPE))
    {
        importType = IMPORT_ENUM_ITEM;
    }
    else if (TREE_CODE (symbol) == TYPE_DECL)
    {
       importType = IMPORT_TYPE;
    }
    else if ((TREE_CODE (symbol) == VAR_DECL) && (TREE_PUBLIC (symbol)))
    {
        importType = IMPORT_VAR_REF_TEMP;
        symbolFileDeclared = -1;
        symbolLineDeclared = -1;
    }
    /* GK  I added the following else if because the program was not 
           catching the 'source/include' import of a static variable.
    */
    else if ((TREE_CODE (symbol) == VAR_DECL) && (TREE_STATIC (symbol)))
    {           
        importType = IMPORT_VAR_REF_TEMP;
        symbolFileDeclared = -1;
        symbolLineDeclared = -1;
    }
    else if (TREE_CODE (symbol) == FUNCTION_DECL) 
    {
        importType = IMPORT_FCN_REF_TEMP;
        symbolFileDeclared = -1;
        symbolLineDeclared = -1;
    }
    else if (TREE_CODE (symbol) == ENUMERAL_TYPE)
    {
       importType = IMPORT_ENUM_TAG;
    }
    else if (TREE_CODE (symbol) == RECORD_TYPE)
    {
       importType = IMPORT_STRUCT;
    }
    else if (TREE_CODE (symbol) == UNION_TYPE)
    {
       importType = IMPORT_UNION;
    }
    else 
    {
       return;
    }
    Cfx_Import_2 (importType, fileAttributed, fileUsed, 
              symbolFileDeclared, symbolLineDeclared, symbolName, scopeName);


/* GK     
    if (posLinkRelFlag == TRUE)
    {
       Cfx_Import_2 (importType, fileAttributed, fileUsed, 
                 symbolFileDeclared, symbolLineDeclared, symbolName, scopeName);
    }
    else
    {
    
       Cfx_Import (importType, fileAttributed, fileUsed, 
                 symbolFileDeclared, symbolLineDeclared, symbolName);
    }
*/

} /* Cfx_ImportSomething */
